<?php

/**
 * @file
 * utility functions for the bynder module
 */

function bynder_orbit_embed_url($filename, $orbitId, $imageStyle = false)
{
    $bynderEntity = db_select('bynder_orbit_media_entity', 'b')
        ->fields('b')
        ->condition('b.bynder_orbit_id', $orbitId, '=')
        ->execute()
        ->fetchAll();

    if (!empty($bynderEntity)) {
        $bynderStyles = unserialize(variable_get('orbit_previews'));
        $imagePreviews = unserialize($bynderEntity[0]->previews);
        $styleName = str_replace('bynder_orbit_', '', $imageStyle);
        // Process custom Bynder previews
        if (in_array($styleName, $bynderStyles)) {
            if (isset($imagePreviews[$styleName])) {
              $previewUrl = $imagePreviews[$styleName]['url'];
              // The first time we get the image and we haven't generated the permanent preview the url won't have the CDN format.
              if(!isOrbitCdnFormat($previewUrl)) {
                $bynderOrbitId = $bynderEntity[0]->bynder_orbit_id;
                $previewUrl = OrbitMediaApi::createOrbitClient()->getThumbnailUrl(
                  $bynderOrbitId,
                  $imagePreviews[$styleName]['width'],
                  $imagePreviews[$styleName]['height']
                );
                if(isset($previewUrl['url'])) {
                  $previewUrl = $previewUrl['url'];
                  $imagePreviews[$styleName]['url'] = $previewUrl;
                  // Save CDN url to database entry.
                  db_merge('bynder_orbit_media_entity')
                    ->fields(array(
                      'previews' => serialize($imagePreviews)
                    ))
                    ->condition('bynder_orbit_id', $bynderOrbitId, '=')
                    ->execute();
                }
              }
              return $previewUrl ;
            }
        }
    }

    drupal_set_message(t('No valid image style found for image @filename, please check your configuration.'
        , array(
            '@filename' => $filename
        )), 'warning');
    // If everything else fails we default to image not found.
    return $GLOBALS['base_url'] . '/' . drupal_get_path('module',
            'bynder_orbit') . '/assets/no-image.png';
}

function isOrbitCdnFormat($url) {
  return preg_match("/.*?(\\/cdn\\/files\\/).*/", $url);
}

function load_files_by_filemime($filemime)
{
    $query = db_select('file_managed', 'f')
        ->fields('f')
        ->condition('f.filemime', $filemime);

    // Load all file ids in an array.
    $fids = $query->execute()->fetchCol();

    // Return the file objects.
    return file_load_multiple($fids);
}

